@echo off
rem This file is part of LaTeX2e CJK package.
rem
rem Generating the Fontmap and the psfonts.map files for temporary use with
rem Ghostscript when making PostScript fonts for CJK package. Alternatively, 
rem the generated file can be appended to the officially released Fontmap and
rem psfonts.map to simulate printer resident PS fonts.
rem
rem Note: you'd better backup the original Fontmap and psfonts.map.

if not "%1" == "" goto start
  echo usage: %0 fontname-prefix fontfile-prefix [psfonts.map [Fontmap]]
  echo   If the 3rd argument is absent, none appended to psfonts.map.
  echo   if the 4th argument is absent, none appended to Fontmap.
  echo   e.g. %0 FunSong b5fs
  goto exit
:start

set fontname=%1
set fontfile=%2
set psfontmap=%3
set gsfontmap=%4

if "%psfontmap%" == "" goto ps_end
if not exist %psfontmap% goto then1
find "%fontname%01" %psfontmap% > nul
if errorlevel 1 goto then1
  goto fi1
:then1
  echo %% > %psfontmap%
  for %%i in (01 02 03 04 05 06 07 08 09 10) do echo %fontfile%%%i %fontname%%%i >> %psfontmap%
  for %%i in (11 12 13 14 15 16 17 18 19 20) do echo %fontfile%%%i %fontname%%%i >> %psfontmap%
  for %%i in (21 22 23 24 25 26 27 28 29 30) do echo %fontfile%%%i %fontname%%%i >> %psfontmap%
  for %%i in (31 32 33 34 35 36 37 38 39 40) do echo %fontfile%%%i %fontname%%%i >> %psfontmap%
  for %%i in (41 42 43 44 45 46 47 48 49 50) do echo %fontfile%%%i %fontname%%%i >> %psfontmap%
  for %%i in (51 52 53 54 55) do echo %fontfile%%%i %fontname%%%i >> %psfontmap%
:fi1
:ps_end

if "%gsfontmap%" == "" goto gs_end
if not exist %gsfontmap% goto then0
find "%fontname%01" %gsfontmap% > nul
if errorlevel 1 goto then0
  goto fi0
:then0
  echo %% > %gsfontmap%
  for %%i in (01 02 03 04 05 06 07 08 09 10) do echo /%fontname%%%i (%fontfile%%%i.pfb) ; >> %gsfontmap%
  for %%i in (11 12 13 14 15 16 17 18 19 20) do echo /%fontname%%%i (%fontfile%%%i.pfb) ; >> %gsfontmap%
  for %%i in (21 22 23 24 25 26 27 28 29 30) do echo /%fontname%%%i (%fontfile%%%i.pfb) ; >> %gsfontmap%
  for %%i in (31 32 33 34 35 36 37 38 39 40) do echo /%fontname%%%i (%fontfile%%%i.pfb) ; >> %gsfontmap%
  for %%i in (41 42 43 44 45 46 47 48 49 50) do echo /%fontname%%%i (%fontfile%%%i.pfb) ; >> %gsfontmap%
  for %%i in (51 52 53 54 55) do echo /%fontname%%%i (%fontfile%%%i.pfb) ; >> %gsfontmap%
:fi0
:gs_end

:exit
set fontname=
set fontfile=
set psfontmap=
set gsfontmap=
